/*
 * Copyright (C) 2012 Samsung Electronics
 * R. Chandrasekar < rcsekar at samsung.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __SOUND_H__
#define __SOUND_H__

#define EPLL_CON0_REG	0x10020130
#define EPLL_CON1_REG	0x10020134
#define EPLL_CON2_REG	0x10020138
#define CLK_SRC_TOP0	0x10020200
#define CLK_SRC_TOP1	0x10020204
#define CLK_SRC_TOP2	0x10020208
#define CLK_SRC_TOP3	0x1002020c
#define CLK_SRC_TOP4	0x10020210
#define CLK_SRC_TOP5	0x10020214
#define CLK_SRC_TOP6	0x10020218
#define CLK_SRC_TOP7	0x1002021c
#define CLK_SRC_TOP9	0x10020224
#define CLK_DIV_TOP0	0x10020500
#define CLK_DIV_TOP1	0x10020504
#define CLK_DIV_TOP2	0x10020508
#define CLK_DIV_TOP9	0x10020524
#define CLK_DIV_PERIC0	0x10020558
#define CLK_DIV_PERIC1	0x1002055c
#define CLK_DIV_PERIC2	0x10020560
#define CLK_DIV_PERIC4	0x10020568

#define I2S_CON		0x03830000
#define I2S_MOD		0x03830004

/*
 * Initialises audio sub system
 *
 * @return     int value 0 for success, -1 for error
 */
int sound_init(void);

/*
 * plays the pcm data buffer in pcm_data.h through i2s0
 *
 * @return     int 0 for success, -1 for error
 */
int sound_play(uint32_t msec, uint32_t frequency);
int play_audio (short * data, unsigned int nsamples, int channel);
#endif  /* __SOUND__H__ */
