/*
 * (C) Copyright 2016
 * Sriram V. <vsriram@mistralsolutions.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */


/* Wave header format */
/* For more details on wave: refer: http://soundfile.sapp.org/doc/WaveFormat/ */

#define MONO		1
#define STEREO		2

#define is_channel_supported(chan) ( (chan < MONO) || (chan > STEREO) ? 0 : 1)

struct wave {
    unsigned char riff[4];
    unsigned int  chunk_size;
    unsigned char wave[4];
    unsigned char fmt_marker[4];
    unsigned int  fmt_len;
    unsigned int  fmt_type;
    unsigned int  channels;
    unsigned int  sample_rate;
    unsigned int  byterate;
    unsigned int  block_align;
    unsigned int  bits_per_sample;
    unsigned char chunk_header [4];
    unsigned int  data_size;
};

struct wave * parse_wave (unsigned char * wave);
int playwave (struct wave *h, char * audio);
